/* =================================================================== */
/*                                 UUDEC.C                             */
/*                                                                     */
/*               (C) 1995, Lenimar Nunes de Andrade                    */
/*                                                                     */
/* Para compilar no DOS:    tcc -mt -lt uudec.c                        */
/*                 UNIX:    gcc uudec.c -o uudec                       */
/* =================================================================== */

/* Decodifica arquivos que estejam no formato uuencode */

#include <stdio.h>
#include <string.h>

int fuu(char *x) {

/* Devolve a posicao do caracter *x no string

   char tabela[] =
     "`!\"#$%&'()*+,-./012356789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_"

   Equivale a  (int) (strchr(tabela, *x) - tabela)  */

   if (*x == '`')
     return 0;
   else
     return (*x - 32);
}

void DecodificaLinha(char *dado, FILE *destino) {

  char a, b, c, d, x, y, z;
  int i, escritos = 0, quant, tam;

  tam = strlen(dado)/4;
  quant = fuu(dado);

  for (i = 0; i < tam; i++) {
    a = fuu(dado + 1 + 4*i);
    b = fuu(dado + 2 + 4*i);
    c = fuu(dado + 3 + 4*i);
    d = fuu(dado + 4 + 4*i);
    x = (a << 2) | (b >> 4);
    if (escritos++ < quant) fputc(x, destino);
    y = (b << 4) | (c >> 2);
    if (escritos++ < quant) fputc(y, destino);
    z = (c << 6) | d;
    if (escritos++ < quant) fputc(z, destino);
  }
}

int main (int argc, char *argv[]) {

  FILE *teste, *destino;
  char linha[100], nome_origem[100], nome_dest[100];

  if (argc < 2) {
    printf("\nForma de usar: uudec arq_origem [arq_destino]\n");
    return 0;
  }

  strcpy(nome_origem, argv[1]);

  if ((teste = fopen(nome_origem, "rt")) != NULL) {

    while ((fgets(linha, 100, teste) != NULL) && (!strstr(linha, "begin")));

    if (argc == 2) {
      /*  O trecho a seguir e' equivalente a
          sscanf(linha, "begin %*d %s", &i, nome_dest); */

      int i, i_inicio, i_fim;

      i_fim = strlen(linha) - 1;
      i_inicio = i_fim - 1;
      while ((linha[i_inicio] != ' ') && (linha[i_inicio] != '/'))
        i_inicio--;
      i_inicio++;
      for (i = i_inicio; i < i_fim; i++)
        nome_dest[i - i_inicio] = linha[i];
      nome_dest[i - i_inicio] = '\0';
    }
    else
      strcpy(nome_dest, argv[2]);

    if ((destino = fopen(nome_dest, "wb")) != NULL) {

      printf("\nDecodificando %s em %s...", nome_origem, nome_dest);
      while (fgets(linha, 100, teste) != NULL) {
        if (linha[0] == '`') break;
        DecodificaLinha(linha, destino);
      }

      fclose(teste);
      fclose(destino);
      printf("\n\n%s decodificado em %s\n", nome_origem, nome_dest);
    }
    else
      printf("\nERRO: Arquivo nao pode ser aberto (%s)\n", nome_dest);
  }
  else
    printf("\nERRO: Arquivo nao encontrado (%s)\n", nome_origem);

  return 1;
}

/*** FIM DE UUDEC.C ***/
