/* =================================================================== */
/*                                 UUENC.C                             */
/*                                                                     */
/*                 (C) 1995, Lenimar Nunes de Andrade                  */
/*                                                                     */
/*     Para compilar no DOS:   tcc -mt -lt uuenc.c                     */
/*                     UNIX:   gcc uuenc.c -o uuenc                    */
/* =================================================================== */

/* UUEncodifica arquivos */

#include <stdio.h>
#include <string.h>

char tabela[] =
    "`!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_";

void CodificaLinha(int n, char *linha, FILE *destino) {

  int i;
  unsigned char ch1, ch2, ch3, ch4, x, y, z;

  fputc(tabela[n], destino);

  if (n > 0) {

    for (i = 0; i < n/3; i++) {
      x = *(linha + 3*i);
      y = *(linha + 3*i + 1);
      z = *(linha + 3*i + 2);
      ch1 = x >> 2;
      fputc(tabela[ch1], destino);
      ch2 = ((x & 3) << 4) | (y >> 4);
      fputc(tabela[ch2], destino);
      ch3 = ((y & 15) << 2) | (z >> 6);
      fputc(tabela[ch3], destino);
      ch4 = z & 63;
      fputc(tabela[ch4], destino);
    }

    if (n < 45) {
      x = *(linha + 3*i);
      y = *(linha + 3*i + 1);
      z = *(linha + 3*i + 2);
      ch1 = x >> 2;
      fputc(tabela[ch1], destino);
      ch2 = ((x & 3) << 4) | (y >> 4);
      fputc(tabela[ch2], destino);
      ch3 = ((y & 15) << 2) | (z >> 6);
      fputc(tabela[ch3], destino);
      ch4 = z & 63;
      fputc(tabela[ch4], destino);
    }
  }

  fputc('\n', destino);
}

int main (int argc, char *argv[]) {

  FILE *origem, *destino;
  char linha[50], nome_origem[100], nome_dest[100];
  int n;

  if (argc < 3) {
    printf("\nForma de usar: uuenc arq_origem arq_destino\n");
    return 0;
  }

  strcpy(nome_origem, argv[1]);
  strcpy(nome_dest, argv[2]);

  if ((origem = fopen(nome_origem, "rb")) !=  NULL) {
    if ((destino = fopen(nome_dest, "wt")) != NULL) {

      printf("\nCodificando %s em %s...", nome_origem, nome_dest);

      fprintf(destino, "begin 644 %s\n", nome_origem);

      do {
         n = fread(linha, 1, 45, origem);
         CodificaLinha(n, linha, destino);
      } while (n);

      fprintf(destino, "end\n");
      fclose(origem);
      fclose(destino);
      printf("\n\n%s codificado em %s\n", nome_origem, nome_dest);
    }
    else
      printf("\nERRO: Arquivo nao pode ser aberto (%s)\n", nome_dest);
  }
  else
    printf("\nERRO: Arquivo nao pode ser aberto (%s)\n", nome_origem);

  return 1;
}

/*** FIM DE UUENC.C ***/
